commit 3dff2f932cfa9168efe8962cba5964f345fd139b
Author: Gaius Mulley <gaiusmod2@gmail.com>
Date:   Tue Dec 3 21:16:25 2024 +0000

    [PATCH] modula2: Reimplement parameter declaration and checking.
    
    This patch improves the parameter declaration by saving all parameter
    kinds: proper procedure, definition module procedure and forward
    procedures.  This allows error messages to reference any parameter
    in the three kinds of procedures.  Variables and their declaration
    are also stored.  The expression, assignment and parameter checking
    has been improved to highlight any variable or parameter and
    its declaration causing a conflict.
    
    gcc/m2/ChangeLog:
    
            * gm2-compiler/M2Base.def (MixTypes): Rename parameters.
            (MixTypesDecl): New procedure function.
            * gm2-compiler/M2Base.mod (BuildOrdFunctions): Add
            DefProcedure parameter to PutFunction.
            (BuildTruncFunctions): Ditto.
            (BuildFloatFunctions): Ditto.
            (BuildIntFunctions): Ditto.
            (InitBaseFunctions): Ditto.
            (MixTypesDecl): New procedure function.
            (MixTypes): Reimplement.
            * gm2-compiler/M2Check.mod (checkProcType): Replace
            NoOfParam with NoOfParamAny.
            Replace IsVarParam with IsVarParamAny.
            (checkProcedureProcType): Ditto.
            * gm2-compiler/M2Error.def: Remove unnecessary export qualified list.
            * gm2-compiler/M2GCCDeclare.mod: Replace NoOfParam with NoOfParamAny.
            Replace IsVarParam with IsVarParamAny.
            (DeclareProcedureToGccWholeProgram): Rename son to
            Variable.
            (DeclareProcedureToGccSeparateProgram): Ditto.
            (PrintKind): New procedure.
            (PrintProcedureParameters): Ditto.
            (PrintProcedureReturnType): Ditto.
            (PrintProcedure): Reimplement.
            (PrintProcTypeParameters): New procedure.
            (PrintProcType): Ditto.
            (DeclareProcType): Rename Son to Parameter.
            * gm2-compiler/M2GenGCC.mod: Replace NoOfParam with NoOfParamAny.
            Replace IsVarParam with IsVarParamAny.
            (ErrorMessageDecl): New procedure.
            (checkIncorrectMeta): Replace call to MetaErrorT2 with
            ErrorMessageDecl.
            (ComparisonMixTypes): Add varleft and varright parameters.
            Adjust all callers of ComparisonMixTypes.
            * gm2-compiler/M2MetaError.def (MetaErrorDecl): New procedure.
            * gm2-compiler/M2MetaError.mod (MetaErrorDecl): New procedure.
            * gm2-compiler/M2Options.def (SetXCode): Add -fd flag description
            to comment.
            * gm2-compiler/M2Options.mod (SetXCode): Add -fd flag description
            to comment.
            * gm2-compiler/M2Quads.mod (CheckBreak): New procedure.
            Replace NoOfParam with NoOfParamAny.
            Replace IsVarParam with IsVarParamAny.
            (FailParameter): Reimplement using GetVarDeclFullTok.
            Generate message for formal parameter, actual parameter and
            declaration of actual parameter.
            (WarnParameter): Ditto.
            (CheckBuildFunction): Reimplement error message using MetaErrorT1.
            * gm2-compiler/M2Range.mod: Replace NoOfParam with NoOfParamAny.
            Replace IsVarParam with IsVarParamAny.
            * gm2-compiler/M2Scaffold.mod (DeclareScaffoldFunctions): Call
            PutProcedureDefined after every procedure declaration.
            (DeclareArgEnvParams): Add ProperProcedure parameter to PutParam.
            * gm2-compiler/M2Size.mod (MakeSize): Add DefProcedure parameter
            to PutFunction.
            * gm2-compiler/M2Swig.mod: Replace NoOfParam with NoOfParamAny.
            Replace IsVarParam with IsVarParamAny.
            * gm2-compiler/M2SymInit.mod: Ditto.
            * gm2-compiler/M2System.mod (InitSystem): Add DefProcedure
            parameter to PutFunction.
            * gm2-compiler/P1SymBuild.mod (StartBuildProcedure): Reimplement.
            (EndBuildProcedure): Ditto.
            (EndBuildForward): Ditto.
            * gm2-compiler/P2Build.bnf (BuildProcedureDefinedByForward):
            Remove.
            (BuildProcedureDefinedByProper): Ditto.
            (ForwardDeclaration): Remove BuildProcedureDefinedByForward.
            (BuildNoReturnAttribute): Remove parameter.
            * gm2-compiler/P2SymBuild.def (BuildNoReturnAttribute): Remove
            parameter.
            (BuildProcedureDefinedByForward): Remove.
            (BuildProcedureDefinedByProper): Ditto.
            * gm2-compiler/P2SymBuild.mod (Import): Remove
            AreParametersDefinedInDefinition,
            AreParametersDefinedInImplementation,
            AreProcedureParametersDefined,
            ParametersDefinedInDefinition,
            ParametersDefinedInImplementation,
            GetProcedureDeclaredDefinition,
            GetProcedureDeclaredForward,
            GetProcedureDeclaredProper,
            GetParametersDefinedByForward,
            GetParametersDefinedByProper and
            PutProcedureNoReturn.
            Add PutProcedureParametersDefined,
            GetProcedureParametersDefined,
            GetProcedureKindDesc,
            GetProcedureDeclaredTok,
            GetProcedureKind,
            GetReturnTypeTok,
            SetReturnOptional,
            IsReturnOptional,
            PutProcedureNoReturn and
            PutProcedureDefined.
            (Debug): New procedure.
            (P2StartBuildDefModule): Space formatting.
            (BuildVariable): Reimplement to record full declaration.
            (StartBuildProcedure): Reimplement using token to determine
            the kind of procedure.
            (BuildProcedureHeading): Ditto.
            (BuildFPSection): Ditto.
            (BuildVarArgs): Ditto.
            (BuildOptArg): Ditto.
            (BuildProcedureDefinedByForward): Remove.
            (BuildProcedureDefinedByProper): Ditto.
            (BuildFormalParameterSection): Reimplement so that the
            quad stack is unchanged.
            (CheckFormalParameterSection): Ditto.
            (RemoveFPParameters): New procedure.
            (ParameterError): Reimplement.
            (StartBuildFormalParameters): Add annotation.
            (ParameterMismatch): Reimplement.
            (EndBuildFormalParameters): Reimplement to check against
            all procedure kinds.
            (GetSourceDesc): Remove.
            (GetCurSrcDesc): Ditto.
            (GetDeclared): Ditto.
            (ReturnTypeMismatch): Reimplement.
            (BuildFunction): Ditto.
            (BuildOptFunction): Ditto.
            (CheckOptFunction): New procedure.
            (BuildNoReturnAttribute): Remove parameter and obtain
            procedure symbol from quad stack.
            (CheckProcedureReturn): New procedure.
            * gm2-compiler/P3SymBuild.mod (BuildOptArgInitializer):
            Preserve ProcSym tok on the quad stack.
            Add Assert.
            * gm2-compiler/PCSymBuild.mod (fixupProcedureType): Replace
            NoOfParam with NoOfParamAny.
            * gm2-compiler/SymbolTable.def (GetNthParam): Add ProcedureKind
            parameter.
            (PutFunction): Ditto.
            (PutOptFunction): Ditto.
            (IsReturnOptional): Ditto.
            (PutParam): Ditto.
            (PutVarParam): Ditto.
            (PutParamName): Ditto.
            (PutProcedureNoReturn): Ditto.
            (IsProcedureNoReturn): Ditto.
            (IsVarParam): Ditto.
            (IsUnboundedParam): Ditto.
            (NoOfParam): Ditto.
            (ForeachLocalSymDo): Ditto.
            (GetProcedureKind): Ditto.
            (GetProcedureDeclaredTok): Ditto.
            (PutProcedureDeclaredTok): Ditto.
            (GetReturnTypeTok): Ditto.
            (PutReturnTypeTok): Ditto.
            (PutParametersDefinedByForward): New procedure.
            (PutProcedureParametersDefined): Ditto.
            (PutProcedureDefined): Ditto.
            (GetParametersDefinedByProper): Ditto.
            (GetProcedureDeclaredForward): Ditto.
            (GetProcedureDeclaredProper): Ditto.
            (PutProcedureDeclaredProper): Ditto.
            (GetProcedureDeclaredDefinition): Ditto.
            (PutProcedureDeclaredDefinition): Ditto.
            (GetProcedureDefined): Ditto.
            (PutUseOptArg): Ditto.
            (UsesOptArg): Ditto.
            (PutOptArgInit): Ditto.
            (SetReturnOptional): Ditto.
            (UsesOptArgAny): Ditto.
            (GetProcedureKindDesc): Ditto.
            (IsReturnOptionalAny): New procedure function.
            (GetNthParamAny): Ditto.
            (NoOfParamAny): Ditto.
            (IsProcedureAnyNoReturn): Ditto.
            (AreParametersDefinedInImplementation): Remove.
            (ParametersDefinedInImplementation): Ditto.
            (AreParametersDefinedInDefinition): Ditto.
            (AreProcedureParametersDefined): Ditto.
            (ParametersDefinedInDefinition): Ditto.
            (ProcedureParametersDefined): Ditto.
            (PutParametersDefinedByProper): Ditto.
            (PutProcedureDeclaredForward): Ditto.
            (GetParametersDefinedByForward): Ditto.
            (GetProcedureParametersDefined): Ditto.
            (PushOffset): Ditto.
            (PopSize): Ditto.
            (PushParamSize): Ditto.
            (PushSumOfLocalVarSize): Ditto.
            (PushSumOfParamSize): Ditto.
            (PopOffset): Ditto.
            (PopSumOfParamSize): Ditto.
            * gm2-compiler/SymbolTable.mod (MakeProcedure): Reimplement.
            (PutProcedureNoReturn): Add ProcedureKind parameter.
            (GetNthParam): Ditto.
            (PutFunction): Ditto.
            (PutOptFunction): Ditto.
            (IsReturnOptional): Ditto.
            (MakeVariableForParam): Ditto.
            (PutParam): Ditto.
            (PutVarParam): Ditto.
            (PutParamName): Ditto.
            (AddParameter): Ditto.
            (IsVarParam): Ditto.
            (IsVarParamAny): Ditto.
            (NoOfParam): Ditto.
            (HasVarParameters): Ditto.
            (IsUnboundedParam): Ditto.
            (PutUseVarArgs): Ditto.
            (UsesVarArgs): Ditto.
            (PutUseOptArg): Ditto.
            (UsesOptArg): Ditto.
            (UsesOptArgAny): Ditto.
            (PutOptArgInit): Ditto.
            (IsProcedure): Ditto.
            (IsPointer): Ditto.
            (IsRecord): Ditto.
            (IsArray): Ditto.
            (IsEnumeration): Ditto.
            (IsUnbounded): Ditto.
            (IsSet): Ditto.
            (IsSetPacked): Ditto.
            (CheckUnbounded): Ditto.
            (IsOAFamily): Ditto.
            (IsModuleWithinProcedure): Ditto.
            (GetDeclaredDef): Ditto.
            (GetDeclaredMod): Ditto.
            (GetDeclaredFor): Ditto.
            (GetProcedureDeclaredForward): Ditto.
            (GetProcedureKind): Ditto.
            (PutProcedureDeclaredForward): Ditto.
            (GetProcedureDeclaredTok): Ditto.
            (GetProcedureDeclaredProper): Ditto.
            (PutProcedureDeclaredTok): Ditto.
            (PutProcedureDeclaredProper): Ditto.
            (GetReturnTypeTok): Ditto.
            (GetProcedureDeclaredDefinition): Ditto.
            (PutReturnTypeTok): Ditto.
            (PutProcedureDeclaredDefinition): Ditto.
            (GetProcedureKindDesc): Ditto.
            (IsProcedureVariable): Ditto.
            (IsAModula2Type): Ditto.
            (GetParam): Ditto.
            (ProcedureParametersDefined): Ditto.
            (AreParametersDefinedInImplementation): Remove.
            (AreParametersDefinedInDefinition): Ditto.
            (AreProcedureParametersDefined): Ditto.
            (IsSizeSolved): Ditto.
            (IsOffsetSolved): Ditto.
            (IsValueSolved): Ditto.
            (IsSumOfParamSizeSolved): Ditto.
            (PushSize): Ditto.
            (PushOffset): Ditto.
            (PopSize): Ditto.
            (PushValue): Ditto.
            (PushParamSize): Ditto.
            (PushSumOfLocalVarSize): Ditto.
            (PushSumOfParamSize): Ditto.
            (PushVarSize): Ditto.
            (PopValue): Ditto.
            (PopSize): Ditto.
            (PopOffset): Ditto.
            (PopSumOfParamSize): Ditto.
            (PutParametersDefinedByForward): New procedure.
            (PutProcedureParametersDefined): Ditto.
            (PutProcedureDefined): Ditto.
            (GetParametersDefinedByProper): Ditto.
            (GetProcedureDeclaredForward): Ditto.
            (GetProcedureDeclaredProper): Ditto.
            (PutProcedureDeclaredProper): Ditto.
            (GetProcedureDeclaredDefinition): Ditto.
            (PutProcedureDeclaredDefinition): Ditto.
            (GetProcedureDefined): Ditto.
            (PutUseOptArg): Ditto.
            (UsesOptArg): Ditto.
            (PutOptArgInit): Ditto.
            (SetReturnOptional): Ditto.
            (UsesOptArgAny): Ditto.
            (GetProcedureKindDesc): Ditto.
            (PutParametersDefinedByProper): Ditto.
            (GetParametersDefinedByProper): Ditto.
            (IsReturnOptionalAny): New procedure function.
            (IsProcedureAnyDefaultBoolean): Ditto.
            (IsProcedureAnyBoolean): Ditto.
            (IsProcedureAnyNoReturn): Ditto.
            (GetNthParamAny): Ditto.
            (NoOfParamAny): Ditto.
            (IsProcedureAnyNoReturn): Ditto.
            (GetProcedureKind): Ditto.
            (IsVarParamAny): Ditto.
            (IsUnboundedParamAny): Ditto.
            (ForeachParamSymDo): New comment.
            * gm2-libs-coroutines/SYSTEM.mod: Reformat.
    
    gcc/testsuite/ChangeLog:
    
            * gm2/iso/fail/badexpression3.mod: New test.
            * gm2/iso/fail/badparam4.def: New test.
            * gm2/iso/fail/badparam4.mod: New test.
    
    (cherry picked from commit 95960cd473297cd0d2c9e75a1a424b870cee32f5)
    
    Signed-off-by: Gaius Mulley <gaiusmod2@gmail.com>

diff --git a/gcc/m2/gm2-compiler/M2Base.def b/gcc/m2/gm2-compiler/M2Base.def
index acf7f851bb6..150e27cfe27 100644
--- a/gcc/m2/gm2-compiler/M2Base.def
+++ b/gcc/m2/gm2-compiler/M2Base.def
@@ -21,95 +21,12 @@ along with GNU Modula-2; see the file COPYING3.  If not see
 
 DEFINITION MODULE M2Base ;
 
-(*
-   Author     : Gaius Mulley
-   Title      : M2Base
-   Date       : 22/5/87
-   Description: Implements the default Base Types and Base
-                procedures in the Modula-2 compiler.
-*)
+(* M2Base implements the default base types and base procedures in the
+   Modula-2 front end.  *)
 
 FROM NameKey IMPORT Name ;
 FROM gcctypes IMPORT location_t ;
 
-EXPORT QUALIFIED Nil,                   (* Base constants          *)
-                 Cardinal,              (* Base types              *)
-                 Integer,
-                 Boolean,
-                 True, False,
-                 Char,
-                 Proc,
-                 LongInt, LongCard,
-                 ShortInt, ShortCard,
-                 ZType, RType, CType,
-                 Real,
-                 LongReal, ShortReal,
-                 Complex,
-                 LongComplex,
-                 ShortComplex,
-                 High, IsOrd,           (* Base functions          *)
-                 LengthS,
-                 Convert,
-                 Re, Im, Cmplx,
-                 Cap, Abs, Odd,
-                 Chr, Val,
-                 IsTrunc, IsFloat,
-                 IsInt,
-                 Min, Max,
-                 New, Dispose,          (* Base procedures         *)
-                 Inc, Dec,
-                 Incl, Excl,
-                 IsPseudoBaseFunction,  (* Manipulation procedures *)
-                 IsPseudoBaseProcedure, (* Manipulation procedures *)
-                 IsBaseType,
-                 GetBaseTypeMinMax,
-                 InitBase,
-                 CannotCheckTypeInPass3,
-                 CheckExpressionCompatible,
-                 CheckAssignmentCompatible,
-                 CheckParameterCompatible,
-                 IsAssignmentCompatible,
-                 IsExpressionCompatible,
-                 IsParameterCompatible,
-                 IsComparisonCompatible,
-                 IsValidParameter,
-                 AssignmentRequiresWarning,
-                 IsMathType,
-                 IsRealType,
-                 IsOrdinalType,
-                 IsComplexType,
-                 GetCmplxReturnType,
-                 ComplexToScalar,
-                 ScalarToComplex,
-                 MixTypes, NegateType,
-                 TemplateProcedure,
-                 ActivationPointer,
-                 IsNeededAtRunTime,
-                 ExceptionAssign,
-                 ExceptionReturn,
-                 ExceptionInc,
-                 ExceptionDec,
-                 ExceptionIncl,
-                 ExceptionExcl,
-                 ExceptionShift,
-                 ExceptionRotate,
-                 ExceptionStaticArray,
-                 ExceptionDynamicArray,
-                 ExceptionForLoopBegin,
-                 ExceptionForLoopTo,
-                 ExceptionForLoopEnd,
-                 ExceptionPointerNil,
-                 ExceptionNoReturn,
-                 ExceptionCase,
-                 ExceptionNonPosDiv,
-                 ExceptionNonPosMod,
-                 ExceptionZeroDiv,
-                 ExceptionZeroRem,
-                 ExceptionWholeValue,
-                 ExceptionRealValue,
-                 ExceptionParameterBounds,
-                 ExceptionNo ;
-
 
 VAR
    TemplateProcedure,
@@ -346,12 +263,24 @@ PROCEDURE CannotCheckTypeInPass3 (e: CARDINAL) : BOOLEAN ;
 
 
 (*
-   MixTypes - returns the type symbol that corresponds to the types t1 and t2.
+   MixTypes - given types leftType and rightType return a type symbol that
+              provides expression type compatibility.
               NearTok is used to identify the source position if a type
               incompatability occurs.
 *)
 
-PROCEDURE MixTypes (t1, t2: CARDINAL; NearTok: CARDINAL) : CARDINAL ;
+PROCEDURE MixTypes (leftType, rightType: CARDINAL; NearTok: CARDINAL) : CARDINAL ;
+
+
+(*
+   MixTypesDecl - returns a type symbol which provides expression compatibility
+                  between leftType and rightType.  An error is emitted if this
+                  is not possible.  left and right are the source (variable,
+                  constant) of leftType and rightType respectively.
+*)
+
+PROCEDURE MixTypesDecl (left, right, leftType, rightType: CARDINAL;
+                        NearTok: CARDINAL) : CARDINAL ;
 
 
 (*
